<?php

namespace Sudalys\ImportService\Processor;

use Sudalys\ImportService\Interfaces\DataProcessorInterface;
//use Sudalys\ImportService\Interfaces\AutreProcessorInterface; // Ajoute d'autres interfaces de traitement si nécessaire

class MainProcessor implements DataProcessorInterface
{
    /**
     * @var DataProcessorInterface[]
     */
    private array $processors = [];

    public function __construct()
    {
        // BasicCsvFileProcessor pas nécessaire ici car déjà géré dans le service d'importation en amont
        $this->processors[] = new DatabaseDataProcessor();
        // $this->processors[] = new AutreProcessor(); // Ajoute d'autres ici au besoin
    }

    public function process(array $row): void
    {
        foreach ($this->processors as $processor) {
            $processor->process($row);
        }
    }
}
