<?php
namespace Sudalys\ImportService\Specification;
use Sudalys\ImportService\Interfaces\ColumnSpecificationInterface;

class RegexColumnSpecification implements ColumnSpecificationInterface
{
    private string $pattern;
    private string $errorMessage;

    public function __construct(string $pattern, string $errorMessage)
    {
        $this->pattern = $pattern;
        $this->errorMessage = $errorMessage;
    }

    public function isSatisfiedBy(string $value): bool
    {
        if(!empty($value) || !trim($value) === '') {
            return preg_match($this->pattern, $value) === 1;
        }else{
            return true;
        }
    }

    public function getErrorMessage(): string
    {
        return $this->errorMessage;
    }
}